import subprocess
import sys
import json
from pathlib import Path

# Our installment path
install_path = Path(__file__).resolve()
install_dir = install_path.parent

# Install and Import the packages for installment
def install_and_import(package):
    try:
        __import__(package)
    except ImportError:
        print(f"Installing {package}...")
        subprocess.check_call([sys.executable, "-m", "pip", "install", package])
    finally:
        globals()[package] = __import__(package)

# Load JSON file with required packages
def load_requirements_from_json(file_path):
    with open(file_path, "r") as file:
        data = json.load(file)
        return data.get("packages", [])
    
# Call our Functions
def main():
    
    json_file = install_dir / "requirments.json" # Path to our JsonFile
    required_packages = load_requirements_from_json(json_file)

    for package in required_packages:
        install_and_import(package)

    print("All required modules are install and ready to use")


if __name__ == "__main__":
    main()
